import { IPublicModelPreference } from '@gant-lowcode/lowcode-types';
/**
 * used to store user preferences, such as pinned status of a pannel.
 * save to local storage.
 */
export default class Preference implements IPublicModelPreference {
    getStorageKey(key: string, module?: string): string;
    set(key: string, value: any, module?: string): void;
    get(key: string, module: string): any;
    /**
     * check if local storage contain certain key
     *
     * @param {string} key
     * @param {string} module
     */
    contains(key: string, module: string): boolean;
}
