"use strict";

var _interopRequireDefault = require("@babel/runtime/helpers/interopRequireDefault");
exports.__esModule = true;
exports.DataSourceServiceManager = void 0;
var _regenerator = _interopRequireDefault(require("@babel/runtime/regenerator"));
var _asyncToGenerator2 = _interopRequireDefault(require("@babel/runtime/helpers/asyncToGenerator"));
var DataSourceServiceManager = exports.DataSourceServiceManager = /*#__PURE__*/function () {
  function DataSourceServiceManager() {
    this.services = new Map();
    this.cache = new Map();
  }
  var _proto = DataSourceServiceManager.prototype;
  _proto.register = function register(key, service) {
    this.services.set(key, service);
  };
  _proto.resolve = /*#__PURE__*/function () {
    var _resolve = (0, _asyncToGenerator2["default"])(/*#__PURE__*/_regenerator["default"].mark(function _callee(key, field, options) {
      var _options$paramsBuilde, _options;
      var cacheKey, service, params, data;
      return _regenerator["default"].wrap(function _callee$(_context) {
        while (1) switch (_context.prev = _context.next) {
          case 0:
            if (options === void 0) {
              options = {};
            }
            cacheKey = options.cacheable ? key : key + "_" + Date.now();
            if (!(options.cacheable && this.cache.has(cacheKey))) {
              _context.next = 4;
              break;
            }
            return _context.abrupt("return", this.cache.get(cacheKey));
          case 4:
            service = this.services.get(key);
            if (service) {
              _context.next = 7;
              break;
            }
            throw new Error("Data source " + key + " not registered");
          case 7:
            params = ((_options$paramsBuilde = (_options = options).paramsBuilder) === null || _options$paramsBuilde === void 0 ? void 0 : _options$paramsBuilde.call(_options, field)) || {};
            _context.next = 10;
            return service(field, params);
          case 10:
            data = _context.sent;
            if (options.cacheable) {
              this.cache.set(cacheKey, data);
            }
            return _context.abrupt("return", data);
          case 13:
          case "end":
            return _context.stop();
        }
      }, _callee, this);
    }));
    function resolve(_x, _x2, _x3) {
      return _resolve.apply(this, arguments);
    }
    return resolve;
  }();
  return DataSourceServiceManager;
}();