"use strict";

exports.__esModule = true;
exports.isGlobalEventOn = isGlobalEventOn;
exports.runWithGlobalEventOff = runWithGlobalEventOff;
exports.setGlobalEventFlag = setGlobalEventFlag;
exports.switchGlobalEventOff = switchGlobalEventOff;
exports.switchGlobalEventOn = switchGlobalEventOn;
exports.wrapWithEventSwitch = wrapWithEventSwitch;
var globalEventOn = true;
function setGlobalEventFlag(flag) {
  globalEventOn = flag;
}
function switchGlobalEventOn() {
  setGlobalEventFlag(true);
}
function switchGlobalEventOff() {
  setGlobalEventFlag(false);
}
function isGlobalEventOn() {
  return globalEventOn;
}
function runWithGlobalEventOff(fn) {
  switchGlobalEventOff();
  fn();
  switchGlobalEventOn();
}
function wrapWithEventSwitch(fn) {
  return function () {
    if (isGlobalEventOn()) fn.apply(void 0, arguments);
  };
}