"use strict";

exports.__esModule = true;
exports.HelpTip = HelpTip;
var _tip = require("./tip");
var _lowcodeUtils = require("@gant-lowcode/lowcode-utils");
function HelpTip(_ref) {
  var help = _ref.help,
    _ref$direction = _ref.direction,
    direction = _ref$direction === void 0 ? 'top' : _ref$direction,
    _ref$size = _ref.size,
    size = _ref$size === void 0 ? 'small' : _ref$size;
  if (typeof help === 'string') {
    return /*#__PURE__*/React.createElement("div", null, (0, _lowcodeUtils.createIcon)('help', {
      size: size,
      className: 'lc-help-tip'
    }), /*#__PURE__*/React.createElement(_tip.Tip, {
      direction: direction
    }, help));
  }
  if (typeof help === 'object' && help.url) {
    return /*#__PURE__*/React.createElement("div", null, /*#__PURE__*/React.createElement("a", {
      href: help.url,
      target: "_blank",
      rel: "noopener noreferrer"
    }, (0, _lowcodeUtils.createIcon)('help', {
      size: size,
      className: 'lc-help-tip'
    })), /*#__PURE__*/React.createElement(_tip.Tip, {
      direction: direction
    }, help.content));
  }
  return /*#__PURE__*/React.createElement("div", null, (0, _lowcodeUtils.createIcon)('help', {
    size: size,
    className: 'lc-help-tip'
  }), /*#__PURE__*/React.createElement(_tip.Tip, {
    direction: direction
  }, help.content));
}